## via 0.1.0

=== DESCRIPTION ===
Package: via
Type: Package
Title: Virtual Arrays
Version: 0.1.0
Authors@R: c(
	person(given="Adam T.", family="Kocsis", role=c("cre", "aut"),
		   email="adam.t.kocsis@gmail.com", comment=c(ORCID="0000-0002-9028-665X")),
	person(given="Deutsche Forschungsgemeinschaft", role="fnd"),
	person(given="FAU GeoZentrum Nordbayern", role="fnd"))
Collate: zzz.R data.R generics.R utility.R classes.R
        VirtualArray-base.R VirtualArray-xattrib.R
        VirtualArray-subset.R VirtualArray-replace.R
        VirtualArray-combine.R XArray-base.R XArray-xattrib.R
        XArray-combine.R RasterArray-base.R RasterArray-xattrib.R
        RasterArray-groupgen.R RasterArray-replace.R
        RasterArray-combine.R RasterArray-rast.R SfArray-base.R
        SfArray-replace.R SfArray-sf.R
Maintainer: Adam T. Kocsis <adam.t.kocsis@gmail.com>
Description: The base class 'VirtualArray' is defined, which acts as a wrapper around lists allowing users to fold arbitrary sequential data into n-dimensional, R-style virtual arrays. The derived 'XArray' class is defined to be used for homogeneous lists that contain a single class of objects. The 'RasterArray' and 'SfArray' classes enable the use of stacked spatial data instead of lists.
License: CC BY 4.0
Date: 2023-03-15
BugReports: https://github.com/adamkocsis/via
Encoding: UTF-8
LazyData: false
Depends: R (>= 4.0.0)
Imports: methods
NeedsCompilation: no
RoxygenNote: 7.2.3
Suggests: tinytest, knitr, rmarkdown, terra, sp, sf
Packaged: 2023-03-15 13:24:33 UTC; root
Author: Adam T. Kocsis [cre, aut] (<https://orcid.org/0000-0002-9028-665X>),
  Deutsche Forschungsgemeinschaft [fnd],
  FAU GeoZentrum Nordbayern [fnd]
Repository: CRAN
Date/Publication: 2023-03-15 19:40:02 UTC

## via 0.2.0

=== DESCRIPTION ===
Package: via
Type: Package
Title: Virtual Arrays
Version: 0.2.0
Authors@R: c(
	person(given="Adam T.", family="Kocsis", role=c("cre", "aut"),
		   email="adam.t.kocsis@gmail.com", comment=c(ORCID="0000-0002-9028-665X")),
	person(given="Deutsche Forschungsgemeinschaft", role="fnd"),
	person(given="FAU GeoZentrum Nordbayern", role="fnd"))
Collate: zzz.R data.R generics.R utility.R classes.R
        VirtualArray-base.R VirtualArray-xattrib.R
        VirtualArray-subset.R VirtualArray-replace.R
        VirtualArray-combine.R XArray-base.R XArray-xattrib.R
        XArray-combine.R RasterArray-base.R RasterArray-xattrib.R
        RasterArray-groupgen.R RasterArray-replace.R
        RasterArray-combine.R RasterArray-rast.R SfcArray-base.R
        SfcArray-replace.R SfcArray-sf.R SfArray-base.R
        SfArray-replace.R conversions.R
Maintainer: Adam T. Kocsis <adam.t.kocsis@gmail.com>
Description: The base class 'VirtualArray' is defined, which acts as a wrapper around lists allowing users to fold arbitrary sequential data into n-dimensional, R-style virtual arrays. The derived 'XArray' class is defined to be used for homogeneous lists that contain a single class of objects. The 'RasterArray' and 'SfArray' classes enable the use of stacked spatial data instead of lists.
License: CC BY 4.0
Date: 2023-05-15
BugReports: https://github.com/adamkocsis/via
Encoding: UTF-8
LazyData: false
Depends: R (>= 4.0.0)
Imports: methods
NeedsCompilation: no
RoxygenNote: 7.2.3
Suggests: tinytest, knitr, rmarkdown, terra, sp, sf
Packaged: 2023-05-16 13:20:28 UTC; root
Author: Adam T. Kocsis [cre, aut] (<https://orcid.org/0000-0002-9028-665X>),
  Deutsche Forschungsgemeinschaft [fnd],
  FAU GeoZentrum Nordbayern [fnd]
Repository: CRAN
Date/Publication: 2023-05-16 13:50:02 UTC

## via 1.6.0

=== CMakeLists.txt ===
PROJECT(VIA)
FIND_PACKAGE(X11 REQUIRED)

# address warnings by cmake 2.6
cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0002 NEW)
endif(COMMAND cmake_policy)

# configure install destinations
SET(VIA_INSTALL_BIN_DIR "${CMAKE_INSTALL_PREFIX}/bin")
SET(VIA_INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib")
SET(VIA_INSTALL_INCLUDE_DIR "${CMAKE_INSTALL_PREFIX}/include")

SET(BUILD_VX off CACHE BOOL "build vxlib")

SET(BUILD_APPS off CACHE BOOL "build apps")
SET(BUILD viaio vialib)

FIND_LIBRARY(LIB_GSL "gsl")
FIND_LIBRARY(LIB_BLAS "blas")
FIND_PATH(GSL_INC "gsl/gsl_cblas.h")#ugly - cant use generic blas

INCLUDE_DIRECTORIES(${GSL_INC})

# choose subprojects
if(BUILD_APPS)
  SET(BUILD ${BUILD} base pgms)
endif(BUILD_APPS)

if(BUILD_VX)
  FIND_PACKAGE(Motif REQUIRED)
  SET(BUILD ${BUILD} vxlib)
endif(BUILD_VX)

SUBDIRS(${BUILD})

# Set default shared library version
# This library version will be applied to all libraries in the package
# unless it is not explicitely for a certain lib.
SET(VIA_VERSION_MAJOR "0")
SET(VIA_VERSION_MINOR "0")
SET(VIA_VERSION_PATCH "0")

SET(VIA_SHAREDLIB_VERSION
    ${VIA_VERSION_MAJOR}.${VIA_VERSION_MINOR}.${VIA_VERSION_PATCH})
STRING(REGEX MATCH "^[0-9]+" VIA_SHAREDLIB_SOVERSION ${VIA_SHAREDLIB_VERSION})
SET(VIA_LIBRARY_PROPERTIES VERSION ${VIA_SHAREDLIB_VERSION}
                           SOVERSION ${VIA_SHAREDLIB_SOVERSION}
                           CLEAN_DIRECT_OUTPUT 1)

# define global include dir for via headers
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include ${X11_Xutil_INCLUDE_PATH} ${X11_Xt_INCLUDE_PATH})

=== base/CMakeLists.txt ===
PROJECT(VIABASE)

SET(BASEPROGS plaintov pnmtov pngtov rawtov vcatobj vcatbands vconvert vcrop vflip
        vimagehisto vinvert vistat vop vrotate vselbands vselect vsynth
        vtopgm vtopnm vnview)

SET(BUILD_VXVIEW off CACHE BOOL "build vxview")

if(BUILD_VXVIEW)
  SET(BASEPROGS ${BASEPROGS} vxview)
endif(BUILD_VXVIEW)

SUBDIRS(${BASEPROGS})

=== viaio/CMakeLists.txt ===
PROJECT(VIAIOLIB)

# get source files
FILE(GLOB VIAIO_SRC *.c)

ADD_LIBRARY(viaio SHARED ${VIAIO_SRC})
# Set library version when building shared libs.
SET_TARGET_PROPERTIES(viaio PROPERTIES ${VIA_LIBRARY_PROPERTIES})

ADD_LIBRARY(viaio_static STATIC ${VIAIO_SRC})
#The library target "viaio_static" has a default OUTPUT_NAME of "viaio_static", can be changed with
SET_TARGET_PROPERTIES(viaio_static PROPERTIES ${VIA_LIBRARY_PROPERTIES} OUTPUT_NAME "viaio")

TARGET_LINK_LIBRARIES(viaio m ${LIB_GSL} ${LIB_BLAS})

# install libraries
INSTALL(TARGETS viaio viaio_static
    RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR} COMPONENT RuntimeLibraries
    LIBRARY DESTINATION ${VIA_INSTALL_LIB_DIR} COMPONENT RuntimeLibraries
    ARCHIVE DESTINATION ${VIA_INSTALL_LIB_DIR} COMPONENT Development)

# install header files
FILE(GLOB VIAIO_HDR "${CMAKE_SOURCE_DIR}/include/viaio/*.h")
INSTALL(FILES ${VIAIO_HDR}
    DESTINATION ${VIA_INSTALL_INCLUDE_DIR}/viaio
    COMPONENT Development)

=== vialib/CMakeLists.txt ===
PROJECT(VIALIB)

# configure source files
FILE(GLOB VIALIB_SRC *.c)

ADD_LIBRARY(via SHARED ${VIALIB_SRC})
# Set library version when building shared libs.
SET_TARGET_PROPERTIES(via PROPERTIES ${VIA_LIBRARY_PROPERTIES})

ADD_LIBRARY(via_static STATIC ${VIALIB_SRC})
#The library target "via_static" has a default OUTPUT_NAME of "via_static", can be changed with
SET_TARGET_PROPERTIES(via_static PROPERTIES ${VIA_LIBRARY_PROPERTIES} OUTPUT_NAME "via")

TARGET_LINK_LIBRARIES(via viaio ${LIB_GSL} ${LIB_BLAS})

# install library
INSTALL(TARGETS via via_static
    RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR} COMPONENT RuntimeLibraries
    LIBRARY DESTINATION ${VIA_INSTALL_LIB_DIR} COMPONENT RuntimeLibraries
    ARCHIVE DESTINATION ${VIA_INSTALL_LIB_DIR} COMPONENT Development)

# install header files
FILE(GLOB VIALIB_HDR "${CMAKE_SOURCE_DIR}/include/*.h")
INSTALL(FILES ${VIALIB_HDR}
    DESTINATION ${VIA_INSTALL_INCLUDE_DIR}/via
    COMPONENT Development)

=== vxlib/CMakeLists.txt ===
PROJECT(VXLIB)

FIND_LIBRARY(LIB_XMU "Xmu")

# configure source files
FILE(GLOB VXLIB_SRC *.c)

INCLUDE_DIRECTORIES(${MOTIF_INCLUDE_DIR})

ADD_LIBRARY(vx SHARED ${VXLIB_SRC})
# Set library version when building shared libs.
SET_TARGET_PROPERTIES(vx PROPERTIES ${VIA_LIBRARY_PROPERTIES})

ADD_LIBRARY(vx_static STATIC ${VXLIB_SRC})
#The library target "vx_static" has a default OUTPUT_NAME of "vx_static", can be changed with
SET_TARGET_PROPERTIES(vx_static PROPERTIES ${VIA_LIBRARY_PROPERTIES} OUTPUT_NAME "vx")

TARGET_LINK_LIBRARIES(vx m viaio ${MOTIF_LIBRARIES} ${X11_Xt_LIB} ${X11_LIBRARIES} ${LIB_XMU})
# MESSAGE(STATUS )

# install library
INSTALL(TARGETS vx vx_static
    RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR} COMPONENT RuntimeLibraries
    LIBRARY DESTINATION ${VIA_INSTALL_LIB_DIR} COMPONENT RuntimeLibraries
    ARCHIVE DESTINATION ${VIA_INSTALL_LIB_DIR} COMPONENT Development)

=== base/plaintov/CMakeLists.txt ===
PROJECT(PLAINTOV)

ADD_EXECUTABLE(plaintov plaintov.c)
TARGET_LINK_LIBRARIES(plaintov via)

INSTALL(TARGETS plaintov
        RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== base/pngtov/CMakeLists.txt ===
PROJECT(PNGTOV)

ADD_EXECUTABLE(pngtov pngtov.c)
TARGET_LINK_LIBRARIES(pngtov via png)

INSTALL(TARGETS pngtov
        RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== base/rawtov/CMakeLists.txt ===
PROJECT(RAWTOV)

ADD_EXECUTABLE(rawtov rawtov.c)
TARGET_LINK_LIBRARIES(rawtov via)

INSTALL(TARGETS rawtov
        RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== base/vcatbands/CMakeLists.txt ===
PROJECT(VCATBANDS)

ADD_EXECUTABLE(vcatbands vcatbands.c)
TARGET_LINK_LIBRARIES(vcatbands via)

INSTALL(TARGETS vcatbands
        RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== base/vcatobj/CMakeLists.txt ===
PROJECT(VCATOBJ)

ADD_EXECUTABLE(vcatobj vcatobj.c)
TARGET_LINK_LIBRARIES(vcatobj via)

INSTALL(TARGETS vcatobj
        RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== base/vflip/CMakeLists.txt ===
PROJECT(VFLIP)

ADD_EXECUTABLE(vflip vflip.c)
TARGET_LINK_LIBRARIES(vflip via)

INSTALL(TARGETS vflip
        RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== base/vinvert/CMakeLists.txt ===
PROJECT(VINVERT)

ADD_EXECUTABLE(vinvert vinvert.c)
TARGET_LINK_LIBRARIES(vinvert via)

INSTALL(TARGETS vinvert
        RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== debian/changelog ===
via (1.6.0-3) unstable; urgency=low

  * Adjust VCS information for the new repository home debian-med.
  * Switch to source package format 3.0 (quilt). Move patches into separate
    series.
  * Adjust build-dep from atlas to libblas-dev (Closes: #554814). Thanks to
    Riku Voipio for reporting.

 -- Michael Hanke <michael.hanke@gmail.com>  Tue, 06 Apr 2010 11:10:11 -0400

via (1.6.0-2) unstable; urgency=low

  * Apply patch to fix an implicit pointer conversion (Closes: #540292).
    Thanks to Dann Frazier.
  * Update Standards-version to 3.8.3.0 -- no changes necessary.

 -- Michael Hanke <michael.hanke@gmail.com>  Mon, 24 Aug 2009 09:39:41 -0400

via (1.6.0-1) unstable; urgency=low

  * Initial release (Closes: #521328).
  * New Upstream Version. Renamed 'vcat' to 'vcatobj' to not conflict with
    atfs package in Debian.
  * Update Standards-version to 3.8.2.0 -- no changes necessary.
  * Update watchfile for recent change in upstream naming scheme.
  * Add versioned dependency on debhelper (>= 5) upon recommendation by
    lintian.

 -- Michael Hanke <michael.hanke@gmail.com>  Fri, 19 Jun 2009 13:50:52 +0200

via (1.5.2+svn3529-2) UNRELEASED; urgency=low

  * Add alternative build-dependency on atlas3-base-dev to be able to build
    the package on Debian etch.
  * FTP access to the upstream sources needs passive mode. Fixed debian/watch.

 -- Michael Hanke <michael.hanke@gmail.com>  Tue, 14 Apr 2009 02:46:10 +0200

via (1.5.2+svn3529-1) UNRELEASED; urgency=low

  * New Upstream SVN snapshot that relocates the VIA lib headers to their new
    cannonical location.

 -- Michael Hanke <michael.hanke@gmail.com>  Tue, 31 Mar 2009 22:08:01 +0200

via (1.5.2-1) UNRELEASED; urgency=low

  * Initial Debian packaging. This is a complete rewrite of the original
    Debian packaging effort done by the upstream developers.

 -- Michael Hanke <michael.hanke@gmail.com>  Thu, 26 Mar 2009 19:46:09 +0100

=== debian/control ===
Source: via
Section: libs
Priority: optional
Maintainer: Michael Hanke <michael.hanke@gmail.com>
Build-Depends: cdbs, debhelper (>= 5), lesstif2-dev, libgsl0-dev, libxaw7-dev, doxygen, cmake, libblas-dev, libpng12-dev | libpng-dev
Standards-Version: 3.8.4.0
Homepage: http://www.cbs.mpg.de/institute/software/lipsia
Vcs-Browser: http://git.debian.org/?p=debian-med/via.git
Vcs-Git: git://git.debian.org/git/debian-med/via.git
XS-DM-Upload-Allowed: yes


Package: libvia0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for volumetric image analysis
 VIA is a volumetric image analysis suite. The included libraries provide
 about 70 image analysis functions.
 .
 This package contains the shared libraries of vialib, vxlib and viaio.


Package: libvia-dev
Section: libdevel
Architecture: any
Depends: libvia0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: library for volumetric image analysis
 VIA is a volumetric image analysis suite. The included libraries provide
 about 70 image analysis functions.
 .
 This package provides the header files and static libraries of vialib, vxlib
 and viaio.


Package: via-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tools for volumetric image analysis
 VIA is a volumetric image analysis suite for functional and structural
 (medical) images. The suite consists of different tools ranging from
 simple data handling over viewers to complex image transformation.
 .
 All tools operate on data in VISTA format. The package contains several
 converters from e.g. PNG, PGM or PNM to this data format and back.


Package: libvia-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: VIA library API documentation
 VIA is a volumetric image analysis suite. The included libraries provide
 about 70 image analysis functions.
 .
 This package provides the library API reference documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# This has to be exported to make some magic below work.
export DH_OPTIONS

DEB_BUILD_PATH=build

export CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	export CFLAG += -O0
else
	export CFLAGS += -O2
endif

CMAKE_FLAGS=-DCMAKE_INSTALL_PREFIX:PATH=/usr \
            -DCMAKE_SKIP_RPATH:BOOL=ON \
            -DBUILD_VX:BOOL=ON \
            -DBUILD_VXVIEW:BOOL=ON \
            -DBUILD_APPS:BOOL=ON \
            -DCMAKE_C_FLAGS:STRING="$$CFLAGS" \
            -DCMAKE_SHARED_LINKER_FLAGS="-Wl,--no-undefined" \
            -DCMAKE_EXE_LINKER_FLAGS="-Wl,--no-undefined"

clean:
	dh_testdir
	
	# Add here commands to clean up after the build process.
	rm -rf $(DEB_BUILD_PATH)
	
	rm -f build-stamp
	rm -f configure-stamp
	dh_clean 

configure: configure-stamp
configure-stamp:
	dh_testdir
	
	if [ ! -d $(DEB_BUILD_PATH) ]; then mkdir $(DEB_BUILD_PATH); fi
	
	cd $(DEB_BUILD_PATH) \
		&& cmake $(CURDIR) $(CMAKE_FLAGS)
	touch configure-stamp

build: build-stamp
build-stamp: configure
	dh_testdir
	dh_clean -k 
	dh_installdirs
	
	cd $(DEB_BUILD_PATH) && $(MAKE) VERBOSE=1
	
	touch build-stamp


install: build
	dh_testdir
	dh_testroot
	dh_clean -k -s
	dh_installdirs -s
	
	# install binaries and shared libs
	cd $(DEB_BUILD_PATH) && $(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
	
	# grab all handwritten manpages, be careful to exclude matches in quilt
	# data
	mkdir -p $(CURDIR)/debian/tmp/man
	for i in $$(find . -name '*.man' | grep -v '^\./\.pc'); do \
		cp -v $$i debian/tmp/man/$$(basename $${i%.man}.1); \
	done
	
	# generate missing manpages with doxygen
	# first update doxygen config
	cp $(CURDIR)/userdoc/Doxyfile debian/tmp/man/Doxyfile.old
	doxygen -u debian/tmp/man/Doxyfile.old
	sed -e 's#/home/dallas1/lohmann/VIA/pgms \\#$(CURDIR)/pgms#g' \
		-e 's#/home/dallas1/lohmann/VIA/base##g' \
		-e 's/GENERATE_HTML          = YES/GENERATE_HTML = NO/g' \
		-e 's/GENERATE_LATEX         = YES/GENERATE_LATEX = NO/g' \
		< debian/tmp/man/Doxyfile.old > debian/tmp/man/Doxyfile
	# run doxygen
	cd debian/tmp/man && doxygen
	# turn man3 into man1
	for m in debian/tmp/man/man/man3/*; do \
		app=$$(basename $$m) ; \
		app=$${app%.c.3} ; \
		if [ -x $(CURDIR)/debian/tmp/usr/bin/$${app} ]; then \
			echo "Converting manpage of $${app}" ; \
			sed -e "s/.TH \"$${app}.c\" 3 /.TH \"$${app}\" 1 /g" \
			    -e "s/$${app}.c/$${app}/g" \
				< $$m > debian/tmp/man/man/$${app}.1 ; \
		fi ; \
	done
	
	# only add generated manpages if no handwritten is available
	for m in $(CURDIR)/debian/tmp/man/man/*.1; do \
		if [ ! -f $(CURDIR)/debian/tmp/man/$$(basename $$m) ]; then \
			cp -v $$m $(CURDIR)/debian/tmp/man/$$(basename $$m); \
		fi; \
	done
	
	# generate API docs with doxygen
	# first update doxygen config
	mkdir -p $(CURDIR)/debian/tmp/api
	cp $(CURDIR)/doc/Doxyfile debian/tmp/api/Doxyfile.old
	sed -e 's#/home/dallas1/lohmann/VIA/vialib /home/dallas1/lohmann/VIA/include#../../../vialib ../../../vxlib ../../../viaio ../../../include#g' \
		-e 's/GENERATE_MAN          = YES/GENERATE_MAN = NO/g' \
		-e 's/GENERATE_LATEX         = YES/GENERATE_LATEX = NO/g' \
		< debian/tmp/api/Doxyfile.old > debian/tmp/api/Doxyfile
	# run doxygen
	doxygen -u debian/tmp/api/Doxyfile
	cd debian/tmp/api && doxygen




# Must not depend on anything. This is to be called by
# # binary-arch/binary-indep
# # in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
	dh_install --sourcedir=$(CURDIR)/debian/tmp
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb


# Build architecture-independent files here.
binary-indep: install
	
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common


# Build architecture-dependent files here.
binary-arch: install
	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common


binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary configure

=== debian/watch ===
version=3
opts=passive \
ftp://lipsia.cbs.mpg.de/lipsia/TGZ/[vV]+[iI]+[aA]+-(\d)\.(.*)\.tar\.gz

## via 2.0.4

=== CMakeLists.txt ===
PROJECT(VIA)

# address warnings by cmake 2.6
cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0002 NEW)
endif(COMMAND cmake_policy)

# add path for new modules
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
	"${CMAKE_SOURCE_DIR}/cmake/Modules")

# configure install destinations
SET(VIA_INSTALL_BIN_DIR "${CMAKE_INSTALL_PREFIX}/bin")
SET(VIA_INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib")
SET(VIA_INSTALL_INCLUDE_DIR "${CMAKE_INSTALL_PREFIX}/include")
SET(VIA_INSTALL_DOC_DIR "${CMAKE_INSTALL_PREFIX}/share/doc/via-utils")

SET(BUILD_VX off CACHE BOOL "build vxlib")

SET(BUILD_APPS off CACHE BOOL "build apps")

# Set default shared library version
# This library version will be applied to all libraries in the package
# unless it is not explicitely for a certain lib.
SET(VIA_VERSION_MAJOR "2")
SET(VIA_VERSION_MINOR "1")
SET(VIA_VERSION_PATCH "0")


SET(VIA_SHAREDLIB_VERSION
    "${VIA_VERSION_MAJOR}.${VIA_VERSION_MINOR}.${VIA_VERSION_PATCH}")

STRING(REGEX MATCH "^[0-9]+" VIA_SHAREDLIB_SOVERSION ${VIA_SHAREDLIB_VERSION})
SET(VIA_LIBRARY_PROPERTIES VERSION ${VIA_SHAREDLIB_VERSION}
                           SOVERSION ${VIA_SHAREDLIB_SOVERSION}
                           CLEAN_DIRECT_OUTPUT 1)


# Find some libs
FIND_PACKAGE(X11 REQUIRED)
IF(NOT X11_Xt_FOUND)
	FIND_PACKAGE(X11_Xt REQUIRED)
ENDIF(NOT X11_Xt_FOUND)

FIND_LIBRARY(LIB_GSL "gsl")
FIND_LIBRARY(LIB_CBLAS "cblas")
FIND_PATH(GSL_INC "gsl/gsl_cblas.h")#ugly - cant use generic blas

INCLUDE_DIRECTORIES(${GSL_INC})

# define global include dir for via headers
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include ${X11_Xutil_INCLUDE_PATH} ${X11_Xt_INCLUDE_PATH})

add_subdirectory(viaio)
add_subdirectory(vialib)

# choose subprojects
if(BUILD_APPS)
  add_subdirectory(base)
  add_subdirectory(pgms)
  INSTALL(PROGRAMS via-help DESTINATION bin)
endif(BUILD_APPS)

if(BUILD_VX)
  FIND_PACKAGE(Motif REQUIRED)
  add_subdirectory(vxlib)
endif(BUILD_VX)


INSTALL(PROGRAMS via-doc DESTINATION bin)

=== base/CMakeLists.txt ===
PROJECT(VIABASE)

SET(BASEPROGS plaintov pnmtov pngtov rawtov vcatobj vcatbands vcrop vflip
        vimagehisto vinvert vistat vop vrotate vselbands vselect vsynth
        vtopgm vtopnm vnview vconvert)

SET(BUILD_VXVIEW off CACHE BOOL "build vxview")

if(BUILD_VXVIEW)
  SET(BASEPROGS ${BASEPROGS} vxview)
endif(BUILD_VXVIEW)

SUBDIRS(${BASEPROGS})

=== pgms/CMakeLists.txt ===
PROJECT(VIAPGMS)

SUBDIRS(vaniso2d vaniso3d vbinarize vbinmorph3d vbinsize vcanny2d vcanny3d
        vcontrast vconvolve2d vconvolve3d vcurvature vdelsmall vderiche3d
        vdist3d vgauss3d vgenus3d vgreymorph3d vhemi vimage2graph
        vimage2volumes visodata vkernel2d vlabel2d vlabel3d vmedian3d
        volumes2image volumeselect vquickmorph3d vscale2d vscale3d vselbig
        vskel2d vskel3d vsmooth3d vthin3d vtopoclass)

=== viaio/CMakeLists.txt ===
--- 
+++ 
@@ -10,8 +10,9 @@
 ADD_LIBRARY(viaio_static STATIC ${VIAIO_SRC})
 #The library target "viaio_static" has a default OUTPUT_NAME of "viaio_static", can be changed with
 SET_TARGET_PROPERTIES(viaio_static PROPERTIES ${VIA_LIBRARY_PROPERTIES} OUTPUT_NAME "viaio")
+MESSAGE(STATUS ${LIB_GSL})
 
-TARGET_LINK_LIBRARIES(viaio m ${LIB_GSL} ${LIB_BLAS})
+TARGET_LINK_LIBRARIES(viaio m ${LIB_GSL} ${LIB_CBLAS})
 
 # install libraries
 INSTALL(TARGETS viaio viaio_static

=== vialib/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 #The library target "via_static" has a default OUTPUT_NAME of "via_static", can be changed with
 SET_TARGET_PROPERTIES(via_static PROPERTIES ${VIA_LIBRARY_PROPERTIES} OUTPUT_NAME "via")
 
-TARGET_LINK_LIBRARIES(via viaio ${LIB_GSL} ${LIB_BLAS})
+TARGET_LINK_LIBRARIES(via viaio ${LIB_GSL} ${LIB_CBLAS})
 
 # install library
 INSTALL(TARGETS via via_static

=== vxlib/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #The library target "vx_static" has a default OUTPUT_NAME of "vx_static", can be changed with
 SET_TARGET_PROPERTIES(vx_static PROPERTIES ${VIA_LIBRARY_PROPERTIES} OUTPUT_NAME "vx")
 
-TARGET_LINK_LIBRARIES(vx m viaio ${MOTIF_LIBRARIES} ${X11_Xt_LIB} ${X11_LIBRARIES} ${LIB_XMU})
+TARGET_LINK_LIBRARIES(vx m viaio ${MOTIF_LIBRARIES} ${X11_Xt_LIB} ${X11_LIBRARIES} ${LIB_XMU} Xt)
 # MESSAGE(STATUS )
 
 # install library

=== base/pngtov/CMakeLists.txt ===
PROJECT(PNGTOV)

FIND_PACKAGE(PNG REQUIRED)
INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
ADD_DEFINITIONS(${PNG_DEFINITIONS})

ADD_EXECUTABLE(pngtov pngtov.c)
TARGET_LINK_LIBRARIES(pngtov via ${PNG_LIBRARY})

INSTALL(TARGETS pngtov
        RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== base/pnmtov/CMakeLists.txt ===
PROJECT(PNMTOV)

ADD_EXECUTABLE(pnmtov pnmtov.c)
TARGET_LINK_LIBRARIES(pnmtov via)

INSTALL(TARGETS pnmtov
        RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== base/vconvert/CMakeLists.txt ===
PROJECT(VCONVERT)

ADD_EXECUTABLE(vconvert vconvert.c)
TARGET_LINK_LIBRARIES(vconvert via)

INSTALL(TARGETS vconvert
        RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== base/vcrop/CMakeLists.txt ===
PROJECT(VCROP)

ADD_EXECUTABLE(vcrop vcrop.c)
TARGET_LINK_LIBRARIES(vcrop via)

INSTALL(TARGETS vcrop
        RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== base/vimagehisto/CMakeLists.txt ===
PROJECT(VIMAGEHISTO)

ADD_EXECUTABLE(vimagehisto vimagehisto.c DispHisto.c ImageHistogram.c)
TARGET_LINK_LIBRARIES(vimagehisto via vx)

INSTALL(TARGETS vimagehisto
        RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== base/vistat/CMakeLists.txt ===
PROJECT(VISTAT)

ADD_EXECUTABLE(vistat vistat.c)
TARGET_LINK_LIBRARIES(vistat via)

INSTALL(TARGETS vistat
        RUNTIME DESTINATION ${VIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== debian/changelog ===
via (2.0.4-2) unstable; urgency=low

  * Add missing dependency x11proto-core-dev to libvia-dev.

 -- Michael Hanke <mih@debian.org>  Thu, 16 Feb 2012 21:54:50 +0100

via (2.0.4-1) unstable; urgency=low

  * New release.

 -- Michael Hanke <mih@debian.org>  Wed, 08 Feb 2012 17:38:27 +0100

via (2.0.3+svn272-0) UNRELEASED; urgency=low

  * fixed bug in VFIllImage

 -- Lipsia Group (The official Lipsia developer group) <lipsia@cbs.mpg.de>  Tue, 29 Nov 2011 12:17:00 +0400

via (2.0.2+svn207-0) UNRELEASED; urgency=low

  * fixed range of VLong

 -- Lipsia Group (The official Lipsia developer group) <lipsia@cbs.mpg.de>  Tue, 05 May 2011 12:17:00 +0400

via (2.0.2+svn206-1) UNRELEASED; urgency=low

  * New upstream release. Changes in ABI, upstream skipped SO version 1 in
    public releases and moved directly to 2. Merged missing_header patch with
    upstream.
  * Fix via-bin archive section (libs -> science).
  * Package now needs libcblas.so, hence build-depends on libatlas.

 -- Michael Hanke <mih@debian.org>  Thu, 05 May 2011 09:53:53 -0400

via (2.0.1+svn191-0) UNRELEASED; urgency=low

  * renamed via-bin to via-utils

 -- Lipsia Group (The official Lipsia developer group) <lipsia@cbs.mpg.de>  Tue, 09 Nov 2010 12:17:00 +0400

via (2.0.0-0) UNRELEASED; urgency=low

  * This version comes with the new lipsia-2.0 package
    and comprises some minor bug fixes
  * Fixed type error of VLong (is now long)

 -- Lipsia Group (The official Lipsia developer group) <lipsia@cbs.mpg.de>  Tue, 09 Nov 2010 12:17:00 +0400

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: via
 Section: libs
 Priority: optional
-Maintainer: Michael Hanke <michael.hanke@gmail.com>
-Build-Depends: cdbs, debhelper (>= 5), lesstif2-dev, libgsl0-dev, libxaw7-dev, doxygen, cmake, libblas-dev, libpng12-dev | libpng-dev
-Standards-Version: 3.8.4.0
+Maintainer: Lipsia Group <lipsia@cbs.mpg.de>
+Uploaders: Michael Hanke <mih@debian.org>
+Build-Depends: debhelper (>= 7.0.50~), lesstif2-dev, libgsl0-dev, libxaw7-dev,
+ doxygen, cmake, libatlas-base-dev, libpng12-dev | libpng-dev
+Standards-Version: 3.9.2
 Homepage: http://www.cbs.mpg.de/institute/software/lipsia
 Vcs-Browser: http://git.debian.org/?p=debian-med/via.git
 Vcs-Git: git://git.debian.org/git/debian-med/via.git
-XS-DM-Upload-Allowed: yes
 
 
-Package: libvia0
+Package: libvia2
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -24,7 +25,9 @@
 Package: libvia-dev
 Section: libdevel
 Architecture: any
-Depends: libvia0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libvia2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
+ x11proto-core-dev
+Conflicts: via-dev
 Description: library for volumetric image analysis
  VIA is a volumetric image analysis suite. The included libraries provide
  about 70 image analysis functions.
@@ -35,7 +38,11 @@
 
 Package: via-bin
 Architecture: any
+Section: science
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Recommends: libvia-doc
+Conflicts: via, via-utils
+Replaces: via-utils
 Description: tools for volumetric image analysis
  VIA is a volumetric image analysis suite for functional and structural
  (medical) images. The suite consists of different tools ranging from

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
srcpkg = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Source:' | cut -d ' ' -f 2,2)
debver = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Version:' | cut -d ' ' -f 2,2 )
upstreamver = $(shell echo $(debver) | cut -d '-' -f 1,1 )

gitver = $(shell [ -x /usr/bin/git ] && git describe --tags --match 'release/*' $$(git merge-base -a HEAD master) | sed -e 's,release/,,g' -e 's/_/./g' -e 's/-/+git/')

# one ring to rule them all ...
%:
	dh $@ --buildsystem=cmake

CMAKE_FLAGS=-DCMAKE_INSTALL_PREFIX:PATH=/usr \
            -DCMAKE_SKIP_RPATH:BOOL=ON \
            -DBUILD_VX:BOOL=ON \
            -DBUILD_VXVIEW:BOOL=ON \
            -DBUILD_APPS:BOOL=ON \
            -DCMAKE_C_FLAGS:STRING="$$CFLAGS" \
            -DCMAKE_SHARED_LINKER_FLAGS="-Wl,--no-undefined" \
            -DCMAKE_EXE_LINKER_FLAGS="-Wl,--no-undefined"

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_install:
	dh_auto_install
	# grab all handwritten manpages, be careful to exclude matches in quilt
	# data
	mkdir -p $(CURDIR)/debian/tmp/man
	for i in $$(find . -name '*.man' | grep -v '^\./\.pc'); do \
		cp -v $$i debian/tmp/man/$$(basename $${i%.man}.1); \
	done
	# generate missing manpages with doxygen
	# first update doxygen config
	cp $(CURDIR)/userdoc/Doxyfile debian/tmp/man/Doxyfile.old
	doxygen -u debian/tmp/man/Doxyfile.old
	sed -e 's#/home/dallas1/lohmann/VIA/pgms \\#$(CURDIR)/pgms#g' \
		-e 's#/home/dallas1/lohmann/VIA/base##g' \
		-e 's/GENERATE_HTML          = YES/GENERATE_HTML = NO/g' \
		-e 's/GENERATE_LATEX         = YES/GENERATE_LATEX = NO/g' \
		< debian/tmp/man/Doxyfile.old > debian/tmp/man/Doxyfile
	# run doxygen
	cd debian/tmp/man && doxygen
	# turn man3 into man1
	for m in debian/tmp/man/man/man3/*; do \
		app=$$(basename $$m) ; \
		app=$${app%.c.3} ; \
		if [ -x $(CURDIR)/debian/tmp/usr/bin/$${app} ]; then \
			echo "Converting manpage of $${app}" ; \
			sed -e "s/.TH \"$${app}.c\" 3 /.TH \"$${app}\" 1 /g" \
			    -e "s/$${app}.c/$${app}/g" \
				< $$m > debian/tmp/man/man/$${app}.1 ; \
		fi ; \
	done
	# only add generated manpages if no handwritten is available
	for m in $(CURDIR)/debian/tmp/man/man/*.1; do \
		if [ ! -f $(CURDIR)/debian/tmp/man/$$(basename $$m) ]; then \
			cp -v $$m $(CURDIR)/debian/tmp/man/$$(basename $$m); \
		fi; \
	done
	# generate API docs with doxygen
	# first update doxygen config
	mkdir -p $(CURDIR)/debian/tmp/api
	cp $(CURDIR)/doc/Doxyfile debian/tmp/api/Doxyfile.old
	sed -e 's#/home/dallas1/lohmann/VIA/vialib /home/dallas1/lohmann/VIA/include#../../../vialib ../../../vxlib ../../../viaio ../../../include#g' \
		-e 's/GENERATE_MAN          = YES/GENERATE_MAN = NO/g' \
		-e 's/GENERATE_LATEX         = YES/GENERATE_LATEX = NO/g' \
		< debian/tmp/api/Doxyfile.old > debian/tmp/api/Doxyfile
	# run doxygen
	doxygen -u debian/tmp/api/Doxyfile
	cd debian/tmp/api && doxygen

override_dh_install:
	dh_install --sourcedir=$(CURDIR)/debian/tmp

get-orig-source:
	# orig tarball, turn directory into something nicer
	git archive --format=tar --prefix=$(srcpkg)-$(gitver)/ $$(git merge-base -a HEAD master) | \
	            gzip -n9 > $(srcpkg)_$(gitver).orig.tar.gz
